///////////////////////////////////////////////////////////////////////////////////////////
// MAT 259 Assignment 4: Bird Migration Patterns Visualization
// Google Image API - See description below
// Modified by Nataly Moreno
//
// Links to download libraries:
//     Unfolded:  http://unfoldingmaps.org
//     ControlP5: http://www.sojamo.de/libraries/controlP5/#installation
//
///////////////////////////////////////////////////////////////////////////////////////////


//Google Image API
//
// GET GOOGLE IMAGES SEARCH RESULTS
//
// I use the ajax.googleapis.com json search results to fetch the image
// urls into a string array and display them one at a time
//
// Youssef Faltas, Feb 2014
//     From: http://www.openprocessing.org/sketch/132752
// With Modifications


String imgUrl, link;

JSONArray result;
JSONObject response;
PImage img = null;

int num = 0;

void GoogleImageSetup()
{
  link = img_url();      // returns an array of image url strings
}

void drawImageFromGoogle()
{
  img = loadImage(link, "jpg");
  img.resize(250, 0);
  if(img != null)
  {
    stroke(0);
    fill(0);
    rect(width - img.width - (width * margin) - 5, 
         height - (height * margin) - 5 - img.height - 35 - 10, 
         img.width + 10, img.height + 10);
         
    image(img, width - img.width - (width * margin), 
          height - (height * margin) - 5 - img.height - 30 - 10, 
          img.width, img.height);
    
    //Title
    textAlign(RIGHT, BOTTOM);
    fill(0);
    textFont(font5);
    text(selectedBird, 
        (width * (1.0 -margin)), 
        height - (height * margin));

    //Move cp5 drop down menu
    BirdSpeciesDDM.
      setPosition((width * (1.0 - margin)) - 200,
                   height - (height * margin) - img.height - 60); 
                  //(height * 0.15) + img.height + 40);
  }
  else
  {
    num++;
    link = img_url();
  }
}

String img_url()
{
  String url, linky;
      
  String searchTerm = selectedBird.replace(' ', '+');
  url = "https://ajax.googleapis.com/ajax/services/search/images?v=1.0&q="+searchTerm+ "&start="+num+"&as_filetype=jpg"+"&imgsz=medium"; //ift:jpg,isz:m";
    
    //https://ajax.googleapis.com/ajax/services/search/images?v=1.0&q=Abert's+Towhee&start=4&as_filetype=jpg&imgsz=medium
              
        // find more search arguments here
        // https://developers.google.com/image-search/v1/jsondevguide#json_args
         
        response = loadJSONObject(url);
        response = response.getJSONObject("responseData");
        result = response.getJSONArray("results");
 
        //for (int i = 0; i < results.size(); i++) {
     
          JSONObject jresult = result.getJSONObject(0);
 
          int high = jresult.getInt("height");
          int wide = jresult.getInt("width");
          String linkstring = jresult.getString("unescapedUrl");
          linky = linkstring;
           
          //println("Photo has height " + high + " and width " + wide + " is at ");
          //println(linkstring);       
        //}
      //}   
   return linky;
}

/*
int numofResults = 1;

String[] imgUrls = new String[0];
String[] links   = new String[0];

JSONArray results;
JSONObject response;
PImage img;
int img_i = 0;

void GoogleImageSetup()
{
  links = img_urls(numofResults);      // returns an array of image url strings
}
  
void drawImageFromGoogle()
{     
   img = loadImage(links[img_i+1],"jpg");
   
   if(img.width > 200)
     img.width = 200;
   if(img.height > 200)
     img.width = 200;
   
   if (img != null ) 
     image(img, width * 0.85, height * 0.3, 
           img.width, img.height);  // display and fit image to display window
   //println(i);
   //println(links[i]); // prints its link to console 
}
  
String[] img_urls(int fours)
{
  String[] url = new String[fours];
  String[] links = new String[fours];
    
  for(int t=0; t<fours; t++)
      {  
        String theSelectedBird = selectedBird.replace(' ', '+');
 
        url[t] = "https://ajax.googleapis.com/ajax/services/search/images?v=1.0&q="+theSelectedBird+ "&start="+(t*4)+"&as_filetype=jpg"+"&imgsz=medium"; //ift:jpg,isz:m";
         
        // find more search arguments here
        // https://developers.google.com/image-search/v1/jsondevguide#json_args
         
        response = loadJSONObject(url[t]);
        response = response.getJSONObject("responseData");
        results = response.getJSONArray("results");
 
        for (int i = 0; i < results.size(); i++) {
     
          JSONObject result = results.getJSONObject(i);
 
          int high = result.getInt("height");
          int wide = result.getInt("width");
          String linkstring = result.getString("unescapedUrl");
          links[(i+(4*t))] = linkstring;
           
          //println("Photo has height " + high + " and width " + wide + " is at ");
          //println(linkstring);       
        }
      }   
   return links;
}*/

