///////////////////////////////////////////////////////////////////////////////////////////
// MAT 259 Assignment 4: Bird Migration Patterns Visualization
// Setting up the Color Palettes File 
// by Nataly Moreno
//
// Colors were obtained from ColorPicker
//     http://tristen.ca/hcl-picker/#/hlc/100/1/302837/FBA4D8
//
// Links to download libraries:
//     ControlP5: http://www.sojamo.de/libraries/controlP5/#installation
//
///////////////////////////////////////////////////////////////////////////////////////////

ArrayList<color[]> colorThemes = new ArrayList<color[]>();
int theme = 0;
int totalThemes = 2;
color threeColor[] = { #958034,#948135,#938235,#928335,#908436,
                       #8F8536,#8E8637,#8D8737,#8B8838,#8A8839,
                       
                       #898939,#878A3A,#868B3B,#858C3C,#838D3D,
                       #828E3E,#808E3F,#7F8F40,#7D9042,#7C9143,
                       
                       #7A9244,#799245,#779347,#769448,#74954A,
                       #73964B,#71964D,#70974E,#6E9850,#6C9952,
                       
                       #6B9953,#699A55,#679B57,#669B58,#649C5A,
                       #629D5C,#619D5E,#5F9E60,#5D9F62,#5C9F64,
                       
                       #5AA066,#58A068,#56A16A,#55A26C,#53A26E,
                       #51A370,#50A372,#4EA474,#4CA476,#4AA579,
                       
                       #49A57B,#47A67D,#45A67F,#44A781,#42A783,
                       #41A886,#3FA888,#3EA98A,#3CA98C,#3BA98E,
                       
                       #3AAA91,#39AA93,#38AB95,#37AB97,#36AB99,
                       #35AC9B,#35AC9E,#35ACA0,#35ACA2,#35ADA4,
                       
                       #35ADA6,#35ADA8,#36AEAA,#37AEAC,#38AEAE,
                       #39AEB0,#3AAEB2,#3CAEB4,#3DAFB6,#3FAFB8,
                       
                       #41AFBA,#43AFBB,#45AFBD,#48AFBF,#4AAFC1,
                       #4DAFC2,#4FAFC4,#52AFC6,#55AFC7,#58AFC9,
                       
                       #5BAFCA,#5EAFCB,#61AFCD,#64AFCE,#67AFCF,
                       #6AAFD1,#6DAFD2,#70AED3,#74AED4,#77AED5
                     };

color rainbow[] = { #CD7358,#CC7455,#CB7552,#C97650,#C7774D,
                    #C5784B,#C37A48,#C17B46,#BF7C44,#BD7D42,
                    
                    #BA7E40,#B8803F,#B5813D,#B2823C,#AF833B,
                    #AC843A,#A98639,#A68739,#A38839,#A08938,
                    
                    #9D8A39,#998B39,#968C3A,#938D3A,#8F8E3B,
                    #8C8F3D,#88903E,#859140,#819141,#7E9243,
                    
                    #7A9345,#769447,#73944A,#6F954C,#6B954F,
                    #689652,#649654,#619757,#5D975A,#59975D,
                    
                    #569860,#529863,#4E9866,#4B9869,#47996D,
                    #449970,#419973,#3D9976,#3A9979,#37997D,
                    
                    #359980,#329883,#309886,#2F9889,#2E988C,
                    #2D978F,#2D9791,#2E9794,#2F9697,#319699,
                    
                    #33959B,#36959E,#3994A0,#3D94A2,#4093A4,
                    #4492A5,#4991A7,#4D91A9,#5190AA,#568FAB,
                    
                    #5A8EAC,#5F8DAD,#648CAD,#688BAE,#6D8AAE,
                    #7189AE,#7687AE,#7B86AE,#7F85AD,#8384AD,
                    
                    #8882AC,#8C81AB,#9080AA,#947EA9,#987DA7,
                    #9C7CA6,#A07AA4,#A379A2,#A778A0,#AA769E,
                    
                    #AD759C,#B0749A,#B37397,#B57295,#B87092,
                    #BA6F8F,#BC6E8C,#BE6E8A,#C06D87,#C26C84
                  };
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
// How To Map a Range
//    http://stackoverflow.com/questions/5731863/mapping-a-numeric-range-onto-another
//
// double slope = 1.0 * (output_end - output_start) / (input_end - input_start)
// output = output_start + slope * (input - input_start)                   
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
void fillColorThemes()
{
  colorThemes.add(threeColor);
  colorThemes.add(rainbow);
}

void chooseFillBasedOnTime(int alphaVal, int theWeek)
{
  colorMode(HSB);  
  float slope = 1.0 * (99.0 - 0.0) / ( 47.0 - 0.0);
  int output = int(round(0.0 + slope * (theWeek - 0.0)));
  
  fill((colorThemes.get(theme)[output] & 0xffffff) | (alphaVal << 24));

}                    
