///////////////////////////////////////////////////////////////////////////////////////////
// MAT 259 Assignment 4: Bird Migration Patterns Visualization
// Drawing Helpers
// by Nataly Moreno
//
// Links to download libraries:
//     Unfolded:  http://unfoldingmaps.org
//     ControlP5: http://www.sojamo.de/libraries/controlP5/#installation
//
///////////////////////////////////////////////////////////////////////////////////////////

void drawStateCenters()
{
  //Draw Center Points on Each State
  stroke(255, 255, 0); //yellow
  
  for (Location coordinate : stateCenters.values()) 
  {
    float zz[] = map.getScreenPositionFromLocation(coordinate);
    ellipse(zz[0], zz[1], 5, 5);
  }
}

void colorBarFill(int i)
{
  int barDiv = 100;
  colorMode(HSB);
  fill(colorThemes.get(theme)[i]);
}

void drawColorBar(float barx, float bary)
{
  int barDiv = 100;
  int barLength = 400;
  int barHeight = 30;
  
  //Fill Color Bar
  for(int i = 0; i < barDiv; i++)
  {
    colorMode(RGB);
    noStroke();
    colorBarFill(i);    
    rect(barx + (i * (barLength / barDiv)), bary, 
         barLength / barDiv, barHeight);
  }

  //Draw Color Bar Outline
  noFill();
  colorMode(RGB);
  stroke(0);
  strokeWeight(1);
  rect(barx, bary, barLength, barHeight);
}
