///////////////////////////////////////////////////////////////////////////////////////////
// MAT 259 Assignment 4: Bird Migration Patterns Visualization
// Print Functions to Help Debug
// by Nataly Moreno
//
// Links to download libraries:
//     Unfolded:  http://unfoldingmaps.org
//     ControlP5: http://www.sojamo.de/libraries/controlP5/#installation
//
///////////////////////////////////////////////////////////////////////////////////////////

void printBirdSpecies()
{
  println("\nPrinting Bird Species: ");
  for(int i = 0; i < BirdSpecies.size(); i++)
  {
    println("    " + BirdSpecies.get(i));
  }
}

void printSelectedBirdyData()
{ 
  if(birdyData.get(selectedBird) != null)
  {
    Bird_Data tempAviData = birdyData.get(selectedBird);
    for(int i = 0; i < 48; i++)
    {
      if(i % 4 == 0 && i < 48)
        println("Month: " + months[(i / 4)]);
        
      println("    i = " + i);
      for(int j = 0; j < tempAviData.bird_states.size(); j++)
      {
        println("         - " + tempAviData.bird_states.get(j) + " " + tempAviData.weekly_bird_data.get(j).get(i));
      }
      println("\n");
    }
  }
  else
  {
    println("ERROR: Data for: " + selectedBird + " has disappeared!");
  }
    
}

void printAnimatedBirdyData()
{  
  println("Printing from Animated BirdyData");
  
  for (Map.Entry aviEntry : birdyData.entrySet()) 
  {
    println("    ~~~~ Birdy Key : " + aviEntry.getKey() + " ~~~~");
    
    Bird_Data tempAviData =  (Bird_Data)aviEntry.getValue();

    //48 weeks, 4 per month
    for(int i = 0; i < 48; i++)
    {
      if(i % 4 == 0 && i < 48)
        println("Month: " + months[(i / 4)]);
        
      println("    i = " + i);
      for(int j = 0; j < tempAviData.bird_states.size(); j++)
      {
        println("         - " + tempAviData.bird_states.get(j) + " " + tempAviData.weekly_bird_data.get(j).get(i));
      }
      println("\n");
    }
  }

  println("End Animated BirdyData Print\n");
}

void printBirdyData()
{
  println("Printing from BirdyData");
  
  for (Map.Entry aviEntry : birdyData.entrySet()) 
  {
    println("    ~~~~ Birdy Key : " + aviEntry.getKey() + " ~~~~");
    Bird_Data tempAviData =  (Bird_Data)aviEntry.getValue();
    println("         - " + tempAviData.bird_states);
    println("         * " + tempAviData.weekly_bird_data);
  }

  println("End BirdyData Print\n");
}
